//+------------------------------------------------------------------+
//|                                                     GapRenko.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


extern int myInput0 = 16; // Default setting for MyInput0
bool firstBar = true;
double renkoHi = 0;
double renkoLo =0;
double renkoMid =0;
double renkoHalf=0;
double fBar=0;
bool upBar= false;
bool gapBar=false;
double gBar=0;
int	gInt=0;


#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Peru
#property indicator_color2 Green
#property indicator_color3 Goldenrod
#property indicator_color4 FireBrick
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer4);
//----
    SetIndexBuffer(0, renkoHi);
     SetIndexBuffer(1, renkoLo);
      SetIndexBuffer(2, renkoHalf);
       SetIndexBuffer(3, renkoMid);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   if (firstBar== true	)
			{	fBar= Close[1];
				if (Close[0]>=fBar+(myInput0*Point))
				{
					upBar=true;
					firstBar=false;
					renkoHi= fBar+(myInput0*Point);
					renkoLo= renkoHi-(myInput0*Point);
					renkoMid=renkoLo;
				}
				if (Close[0]<=fBar-(myInput0*Point))
				{
					
					upBar=false;
					renkoLo= fBar-(myInput0*Point);
					renkoHi= renkoLo+(myInput0*Point);
					renkoMid=renkoHi;
					firstBar=false;
				}
			}	
				
			if (firstBar==false)
			{	
				if( Bid()-Close[1]>(myInput0*Point)
				&& (Bid() > renkoHi+(myInput0*Point))
				{
					gBar= ( Bid()-Close[1])/Point/myInput0;
					gInt= NormalizeDouble(gBar,0);
					//Print(gBar+"ghi"+gInt);
					renkoHi=renkoHi+((myInput0*gInt)*Point);
					renkoLo= renkoHi-(myInput0*Point);
					renkoMid=renkoLo;
					upBar=true;}
				
				
				if(Close[1]-Close[0]>(myInput0*Point)
				 && Bid()< renkoLo-(myInput0*Point))
				{
					gBar= (Bid()-Close[1])/Point/myInput0;
					gInt= NormalizeDouble(gBar,0);
					//Print(gBar+"glo"+gInt);
					
					renkoLo= renkoLo+(myInput0*Point)*gInt;
					renkoHi=renkoLo+(myInput0*Point);
					renkoMid=renkoLo;
					upBar=false;}
													
				
				if (upBar== true
					&& Bid() >= renkoHi+(myInput0*Point))
				{
					renkoHi=renkoHi+(myInput0*Point);
					renkoLo= renkoHi-(myInput0*Point);
					renkoMid=renkoLo;}
				
				if (upBar== false
					&& Bid()<= renkoLo-(myInput0*Point))
				{
					renkoLo=renkoLo-(myInput0*Point);
					renkoHi= renkoLo+(myInput0*Point);
					renkoMid=renkoHi;}
				// reverse
				if (upBar== true
					&& Bid() <= renkoLo-(myInput0*Point))
				{
					renkoMid=renkoLo;
					renkoLo= renkoLo-(myInput0*Point);
					renkoHi=renkoLo+(myInput0*Point);					
					upBar=false;}
					
				
				if (upBar== false
					&& Bid()>= renkoHi+(myInput0*Point))
				{
					renkoMid=renkoHi;
					renkoHi=renkoHi+(myInput0*Point);
					renkoLo= renkoHi-(myInput0*Point);
					
					upBar= true;}
				
				if (upBar== true && Bid()>=renkoHi+(.5*myInput0*Point))
				{
					renkoHalf=renkoHi-(.5*myInput0*Point);}
					
				if (upBar== false && Bid()<=renkoLo-(.5*myInput0*Point))
				{
					renkoHalf=renkoLo+(.5*myInput0*Point);}
                        
						
			
//----
   return(0);}
  }
   
  
//}+------------------------------------------------------------------+




// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// Enter the description of your new custom indicator here
    /// </summary>
    [Description("Enter the description of your new custom indicator here")]
    public class IanRenko : Indicator
    {
        #region Variables
        // Wizard generated variables
             private int myInput0 = 8; // Default setting for MyInput0
			private bool firstBar = true;
			private double renkoHi = 0;
			private double renkoLo =0;
			private double renkoMid =0;
			private double renkoHalf=0;
			private double fBar=0;
			private bool upBar= false;
			private bool gapBar=false;
			private double gBar=0;
			private int	gInt=0;
		
        // User defined variables (add any user defined variables below)
        #endregion

        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {
            Add(new Plot(Color.FromKnownColor(KnownColor.Peru), PlotStyle.Line, "Plot0"));
            Add(new Plot(Color.FromKnownColor(KnownColor.Green), PlotStyle.Line, "Plot1"));
            Add(new Plot(Color.FromKnownColor(KnownColor.LightGoldenrodYellow), PlotStyle.Line, "Plot2"));
            Add(new Plot(Color.FromKnownColor(KnownColor.Firebrick), PlotStyle.Line, "Plot3"));
            CalculateOnBarClose	= false;
            Overlay				= false;
            PriceTypeSupported	= false;
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
			if(CurrentBar<10)
			{
				return;}
			
			if (firstBar== true
				)
			{	fBar= Close[1];
				if (Close[0]>=fBar+(myInput0*TickSize))
				{
					upBar=true;
					firstBar=false;
					renkoHi= fBar+(myInput0*TickSize);
					renkoLo= renkoHi-(myInput0*TickSize);
					renkoMid=renkoLo;
				}
				if (Close[0]<=fBar-(myInput0*TickSize))
				{
					
					upBar=false;
					renkoLo= fBar-(myInput0*TickSize);
					renkoHi= renkoLo+(myInput0*TickSize);
					renkoMid=renkoHi;
					firstBar=false;
				}}
				
			if (firstBar==false)
			{	
				if( GetCurrentBid()-Close[1]>(myInput0*TickSize)
				&& GetCurrentBid() > renkoHi+(myInput0*TickSize))
				{
					gBar= ( GetCurrentBid()-Close[1])/TickSize/myInput0;
					gInt= (int)gBar;
					//Print(gBar+"ghi"+gInt);
					renkoHi=renkoHi+((myInput0*gInt)*TickSize);
					renkoLo= renkoHi-(myInput0*TickSize);
					renkoMid=renkoLo;
					upBar=true;}
				
				
				if(Close[1]-Close[0]>(myInput0*TickSize)
				 && GetCurrentBid()< renkoLo-(myInput0*TickSize))
				{
					gBar= (GetCurrentBid()-Close[1])/TickSize/myInput0;
					gInt= (int)gBar;
					//Print(gBar+"glo"+gInt);
					
					renkoLo= renkoLo+(myInput0*TickSize)*gInt;
					renkoHi=renkoLo+(myInput0*TickSize);
					renkoMid=renkoLo;
					upBar=false;}
													
				
				if (upBar== true
					&& GetCurrentBid() >= renkoHi+(myInput0*TickSize))
				{
					renkoHi=renkoHi+(myInput0*TickSize);
					renkoLo= renkoHi-(myInput0*TickSize);
					renkoMid=renkoLo;}
				
				if (upBar== false
					&& GetCurrentBid()<= renkoLo-(myInput0*TickSize))
				{
					renkoLo=renkoLo-(myInput0*TickSize);
					renkoHi= renkoLo+(myInput0*TickSize);
					renkoMid=renkoHi;}
				// reverse
				if (upBar== true
					&& GetCurrentBid() <= renkoLo-(myInput0*TickSize))
				{
					renkoMid=renkoLo;
					renkoLo= renkoLo-(myInput0*TickSize);
					renkoHi=renkoLo+(myInput0*TickSize);
					
					upBar=false;}
				
				if (upBar== false
					&& GetCurrentBid()>= renkoHi+(myInput0*TickSize))
				{
					renkoMid=renkoHi;
					renkoHi=renkoHi+(myInput0*TickSize);
					renkoLo= renkoHi-(myInput0*TickSize);
					
					upBar= true;}
				
				if (upBar== true && GetCurrentBid()>=renkoHi+(.5*myInput0*TickSize))
				{
					renkoHalf=renkoHi-(.5*myInput0*TickSize);}
				if (upBar== false && GetCurrentBid()<=renkoLo-(.5*myInput0*TickSize))
				{
					renkoHalf=renkoLo+(.5*myInput0*TickSize);}
						
				
				
			}
		
            // Use this method for calculating your indicator values. Assign a value to each
            // plot below by replacing 'Close[0]' with your own formula.
         
			Plot0.Set(renkoHi);
            Plot1.Set(renkoLo);
            Plot2.Set(renkoHalf);
            Plot3.Set(renkoMid);
        }
		

        #region Properties
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Plot0
        {
            get { return Values[0]; }
        }

        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Plot1
        {
            get { return Values[1]; }
        }

        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Plot2
        {
            get { return Values[2]; }
        }

        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Plot3
        {
            get { return Values[3]; }
        }

        [Description("Ticks in range")]
        [Category("Parameters")]
        public int MyInput0
        {
            get { return myInput0; }
            set { myInput0 = Math.Max(1, value); }
        }
        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private IanRenko[] cacheIanRenko = null;

        private static IanRenko checkIanRenko = new IanRenko();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public IanRenko IanRenko(int myInput0)
        {
            return IanRenko(Input, myInput0);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public IanRenko IanRenko(Data.IDataSeries input, int myInput0)
        {
            checkIanRenko.MyInput0 = myInput0;
            myInput0 = checkIanRenko.MyInput0;

            if (cacheIanRenko != null)
                for (int idx = 0; idx < cacheIanRenko.Length; idx++)
                    if (cacheIanRenko[idx].MyInput0 == myInput0 && cacheIanRenko[idx].EqualsInput(input))
                        return cacheIanRenko[idx];

            IanRenko indicator = new IanRenko();
            indicator.BarsRequired = BarsRequired;
            indicator.CalculateOnBarClose = CalculateOnBarClose;
            indicator.Input = input;
            indicator.MyInput0 = myInput0;
            indicator.SetUp();

            IanRenko[] tmp = new IanRenko[cacheIanRenko == null ? 1 : cacheIanRenko.Length + 1];
            if (cacheIanRenko != null)
                cacheIanRenko.CopyTo(tmp, 0);
            tmp[tmp.Length - 1] = indicator;
            cacheIanRenko = tmp;
            Indicators.Add(indicator);

            return indicator;
        }

    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.IanRenko IanRenko(int myInput0)
        {
            return _indicator.IanRenko(Input, myInput0);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.IanRenko IanRenko(Data.IDataSeries input, int myInput0)
        {
            return _indicator.IanRenko(input, myInput0);
        }

    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.IanRenko IanRenko(int myInput0)
        {
            return _indicator.IanRenko(Input, myInput0);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.IanRenko IanRenko(Data.IDataSeries input, int myInput0)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.IanRenko(input, myInput0);
        }

    }
}
#endregion

